<script lang="ts" setup>
import type { BaseHero } from '@/types/base';
// This component is used on:
// /free-trial
// /de-de/impressum/
// /fr-fr/mentions-legales/
// /stages-devops-lifecycle
// /terms/

type SimpleHero = BaseHero & {
  config?: {
    aosAnimation?: number;
    aosDuration?: number;
    centered?: boolean;
    hasHorizontalRule?: boolean;
  };
};

const props = defineProps<SimpleHero>();

const hasButtons = computed(() => !!props.primaryButton || !!props.secondaryButton);
</script>

<template>
  <section class="cta" :data-aos="config?.aosAnimation" :data-aos-duration="config?.aosDuration">
    <SlpContainer>
      <SlpRow>
        <SlpColumn class="cta__body">
          <div
            :class="{
              'slp-mb-32': hasButtons,
              centered: config?.centered,
            }"
            class="cta__header"
          >
            <SlpTypography tag="h1" variant="heading1-bold">{{ header }}</SlpTypography>
            <div v-if="subHeader" class="cta__subtitle" v-html="$md.render(subHeader)" />
            <SlpTypography v-if="text" tag="p" variant="body1" class="cta__text">{{ text }}</SlpTypography>
          </div>
          <div v-if="hasButtons" class="slp-mb-32 cta__buttons" :class="{ centered: config?.centered }">
            <SlpButton
              v-if="primaryButton"
              class="slp-mr-8"
              variant="primary"
              :data-ga-name="primaryButton.config.dataGaName"
              :data-ga-location="primaryButton.config.dataGaLocation"
              :href="primaryButton.config.href"
              >{{ primaryButton.text }}</SlpButton
            >
            <SlpButton
              v-if="secondaryButton"
              variant="secondary"
              :href="secondaryButton.config.href"
              :data-ga-name="secondaryButton.config.dataGaName"
              :data-ga-location="secondaryButton.config.dataGaLocation"
              >{{ secondaryButton.text }}</SlpButton
            >
          </div>
        </SlpColumn>
        <CommonHorizontalRule v-if="config?.hasHorizontalRule" class="slp-mb-32 slp-mt-32 slp-mb-md-0 slp-mt-md-64" />
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.cta {
  margin: $spacing-96 $spacing-0;

  @media (max-width: $breakpoint-md) {
    margin-top: $spacing-16;
    margin-bottom: $spacing-16;
  }

  @media (max-width: $breakpoint-sm) {
    overflow-x: clip;
  }

  &__body {
    padding-right: $spacing-32;
    @media (max-width: $breakpoint-md) {
      padding-right: 0;
    }
  }

  &__text {
    margin: $spacing-0 auto;
    @media (min-width: $breakpoint-md) {
      width: 65%;
      margin-top: $spacing-16;
    }
  }

  &__header {
    text-align: center;

    &:not(.centered) {
      text-align: left;
    }
  }

  &__subtitle {
    margin-top: $spacing-24;
    margin-bottom: $spacing-16;

    @media (min-width: $breakpoint-md) {
      line-height: 28px;
      margin-bottom: unset;
    }

    &:deep(a.subscript) {
      font-size: 14px;
      display: inline-block;
      vertical-align: super;
      line-height: 18px;
    }
  }

  &__buttons {
    display: flex;
    flex-direction: column;

    &.centered {
      justify-content: center;
    }

    a {
      width: 100%;
      margin-bottom: $spacing-8;

      @media (min-width: $breakpoint-md) {
        width: inherit;
        margin-bottom: inherit;
      }
    }

    @media (min-width: $breakpoint-sm) {
      flex-direction: row;
    }
  }
}
</style>
